-- View: idm_rpt_cfg.idmrpt_user_events_v

DROP VIEW idm_rpt_cfg.idmrpt_user_events_v CASCADE;

CREATE OR REPLACE VIEW idm_rpt_cfg.idmrpt_user_events_v AS 
 SELECT event.event_id AS event_seq_no, event.event_name, event.rv40 AS event_id, event.event_datetime, idm_rpt_cfg.get_formatted_user_dn(event.init_user_domain, event.init_user_name) AS event_source_user, idm_rpt_cfg.get_formatted_user_dn(event.target_user_domain, event.target_user_name) AS event_destination_user, id.full_name AS event_target_user_name, event.base_message AS message, event.file_name, event.rv31, idv_driver.idv_name, idv_driver.idv_host, idv_driver.idv_id, idv_driver.rpt_drv_id, id.identity_id, id.first_name, id.last_name, id.middle_initial, id.full_name, id.job_title, id.department, id.location, id.email_address, id.identity_desc, event.rv43, event.xdas_taxonomy_id, evt_xdas_txnmy_rpt_v.xdas_provider, evt_xdas_txnmy_rpt_v.xdas_registry, evt_xdas_txnmy_rpt_v.xdas_class, evt_xdas_txnmy_rpt_v.xdas_identifier, evt_xdas_txnmy_rpt_v.xdas_taxonomy_name
   FROM idm_rpt_cfg.idmrpt_identity_v1 id
   JOIN idm_rpt_cfg.idmrpt_idv_acct_all_v id_acct ON id.identity_id::text = id_acct.identity_id::text
   JOIN idm_rpt_cfg.idmrpt_idv_v idv ON id_acct.idv_id::text = idv.idv_id::text
   JOIN idm_rpt_cfg.idmrpt_rpt_driver_v idv_driver ON id_acct.rpt_drv_id::text = idv_driver.rpt_drv_id::text
   JOIN events_rpt_v3 event ON 
CASE
WHEN event.target_user_name IS NULL THEN 
CASE
    WHEN event.init_user_name IS NULL THEN id_acct.idv_acct_user::text = lower(event.init_user_id::text)
    ELSE id_acct.idv_acct_user::text = lower(event.init_user_name::text)
END
ELSE 
CASE
    WHEN event.target_user_name::text ~~ '%cn=%o=%'::text THEN lower(event.target_user_name::text) = lower(id_acct.idv_acct_dn::text)
    ELSE 
    CASE
        WHEN event.target_user_name::text = 'loginDisabled'::text OR event.target_user_name::text = 'Locked By Intruder'::text OR event.target_user_name::text ~~ 'Login Intruder%'::text THEN id_acct.idv_acct_user::text = lower(event.init_user_name::text)
        ELSE id_acct.idv_acct_user::text = lower(event.target_user_name::text)
    END
END
END AND 
CASE
    WHEN event.target_user_domain IS NULL THEN id_acct.idv_acct_domain::text = lower(event.init_user_domain::text)
    ELSE 
    CASE
        WHEN event.target_user_domain::text ~~ '%cn=%o=%'::text THEN id_acct.idv_acct_dn::text = lower(event.target_user_domain::text)
        ELSE id_acct.idv_acct_domain::text = lower(event.target_user_domain::text)
    END
END
   LEFT JOIN evt_xdas_txnmy_rpt_v ON evt_xdas_txnmy_rpt_v.xdas_taxonomy_id = event.xdas_taxonomy_id;

ALTER TABLE idm_rpt_cfg.idmrpt_user_events_v
  OWNER TO idmrptsrv;
GRANT ALL ON TABLE idm_rpt_cfg.idmrpt_user_events_v TO idmrptsrv;
GRANT SELECT ON TABLE idm_rpt_cfg.idmrpt_user_events_v TO idmrptuser;